import javax.swing.*;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import java.awt.Color;
import java.awt.event.*;
import java.util.*;

public class Ruku extends javax.swing.JFrame {

	// +++++++++++++These variables used only in the GUI-interface+++++++++++++++++++++++++++++++++++++++++++++++++++++++
	private static final long serialVersionUID = 1L;
	private JButton[][] facelet = new JButton[6][9];
	private final JButton[] colorSel = new JButton[6];
	private final int FSIZE = 45;
	private final int[] XOFF = { 3, 6, 3, 3, 0, 9 };// Offsets for facelet display
	private final int[] YOFF = { 0, 3, 3, 6, 3, 3 };
	private final Color[] COLORS = { Color.red, Color.green, Color.white, Color.orange, Color.blue, Color.yellow };
	private JCheckBox checkBoxShowStr;
	private JButton buttonRandom;
	private JCheckBox checkBoxUseSep;

	private JButton Solve;
	private JLabel jLabel2;
	private JLabel jLabel1;
	private JSpinner spinnerMaxMoves;
	private JSpinner spinnerTimeout;
	private Color curCol = COLORS[0];
	private int maxDepth = 24, maxTime = 5;
	boolean useSeparator = true;
	boolean showString = false;

	// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	public static void main(String[] args) {
		SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				Ruku inst = new Ruku();
				inst.setLocationRelativeTo(null);
				inst.setVisible(true);
			}
		});
	}

	// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	public Ruku() {
		super();
		initGUI();
	}

	// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	private void initGUI() {

		getContentPane().setLayout(null);
		setDefaultCloseOperation(WindowConstants.DISPOSE_ON_CLOSE);
		this.setTitle("Ruku");

		// ++++++++++++++++++++++++++++++++++ Set up Solve Cube Button ++++++++++++++++++++++++++++++++++++++++++++++++++++
		Solve = new JButton("Print Cube String");
		getContentPane().add(Solve);
		Solve.setBounds(400, 64, 150, 48);
		Solve.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent evt) {
				solveCube(evt);
			}
		});
        
        
        {
            buttonRandom = new JButton("Reset");
            getContentPane().add(buttonRandom);
            buttonRandom.setBounds(422, 17, 114, 22);
            buttonRandom.setText("Reset");
            buttonRandom.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    // +++++++++++++++++++++++++++++ Call Random function from package org.kociemba.twophase ++++++++++++++++++++
                    // ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
                    for (int i = 0; i < 6; i++)
                        for (int j = 0; j < 9; j++) {
                            
                            if(j != 4)
                                facelet[i][j].setBackground(Color.gray);

                        }
                }
            });
        }
        
        

		// ++++++++++++++++++++++++++++++++++ Set up editable facelets ++++++++++++++++++++++++++++++++++++++++++++++++++++
		for (int i = 0; i < 6; i++)
			for (int j = 0; j < 9; j++) {
				facelet[i][j] = new JButton();
				getContentPane().add(facelet[i][j]);
				facelet[i][j].setBackground(Color.gray);
				facelet[i][j].setRolloverEnabled(false);
				facelet[i][j].setOpaque(true);
				facelet[i][j].setBounds(FSIZE * XOFF[i] + FSIZE * (j % 3), FSIZE * YOFF[i] + FSIZE * (j / 3), FSIZE, FSIZE);
				facelet[i][j].addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent evt) {
						((JButton) evt.getSource()).setBackground(curCol);
					}
				});
			}
        String[] txt = { "R", "G", "W", "O", "B", "Y" };
        for (int i = 0; i < 6; i++) {
            facelet[i][4].setText(txt[i]);
            if(txt[i] == "R")
            {
                facelet[i][4].setBackground(Color.red);

            }
            if(txt[i] == "G")
            {
                facelet[i][4].setBackground(Color.green);

            }
            if(txt[i] == "W")
            {
                facelet[i][4].setBackground(Color.white);

            }
            if(txt[i] == "O")
            {
                facelet[i][4].setBackground(Color.orange);

            }
            if(txt[i] == "B")
            {
                facelet[i][4].setBackground(Color.blue);

            }
            if(txt[i] == "Y")
            {
                facelet[i][4].setBackground(Color.yellow);

            }
            
        }
		for (int i = 0; i < 6; i++) {
			colorSel[i] = new JButton();
			getContentPane().add(colorSel[i]);
			colorSel[i].setBackground(COLORS[i]);
			colorSel[i].setOpaque(true);
			colorSel[i].setBounds(FSIZE * (XOFF[1] + 1) + FSIZE / 4 * 3 * i, FSIZE * (YOFF[3] + 1), FSIZE / 4 * 3,
					FSIZE / 4 * 3);
			colorSel[i].setName("" + i);
			colorSel[i].addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent evt) {
					curCol = COLORS[Integer.parseInt(((JButton) evt.getSource()).getName())];
				}
			});

		}
		pack();
		this.setSize(556, 441);
	}

	// ++++++++++++++++++++++++++++++++++++ End initGUI +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

	// +++++++++++++++++++++++++++++++ Generate cube from GUI-Input and solve it ++++++++++++++++++++++++++++++++++++++++
	private void solveCube(ActionEvent evt) {
		StringBuffer s = new StringBuffer(9);

		for (int i = 0; i < 9; i++)
			s.insert(i, 'T');// default initialization

        Hashtable<String, String> sides = new Hashtable<String, String>();
        
        String[] sidesArray = { "R", "G", "W", "O", "B", "Y" };
        
        for (int i = 0; i < 6; i++) {
            // read the 54 facelets
            for (int j = 0; j < 9; j++) {
                if (facelet[i][j].getBackground() == facelet[0][4].getBackground())
                    s.setCharAt(j, 'r');
                if (facelet[i][j].getBackground() == facelet[1][4].getBackground())
                    s.setCharAt(j, 'g');
                if (facelet[i][j].getBackground() == facelet[2][4].getBackground())
                    s.setCharAt(j, 'w');
                if (facelet[i][j].getBackground() == facelet[3][4].getBackground())
                    s.setCharAt(j, 'o');
                if (facelet[i][j].getBackground() == facelet[4][4].getBackground())
                    s.setCharAt(j, 'b');
                if (facelet[i][j].getBackground() == facelet[5][4].getBackground())
                    s.setCharAt(j, 'y');
            }
            sides.put(sidesArray[i], s.toString());
            
        }

        String cubeString = sides.get("R") + sides.get("G") + sides.get("W") + sides.get("O") + sides.get("B") + sides.get("Y");
        System.out.println("sides:" + sides + "\nfinalstring: " + cubeString);
        
		JOptionPane.showMessageDialog(null, cubeString);
		// ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
	}
}
